diff --git a/libpurple/request.h b/libpurple/request.h
--- a/libpurple/request.h
+++ b/libpurple/request.h
@@ -45,6 +45,7 @@ typedef struct _PurpleRequestUiOps Purpl
 
 #include "purpleaccount.h"
 #include "purpleconversation.h"
+#include "purpleversion.h"
 #include "request/purplerequestpage.h"
 #include "request/purplerequestgroup.h"
 #include "request/purplerequestfield.h"
@@ -227,7 +228,10 @@ G_BEGIN_DECLS
  * the UI to display the request.
  *
  * Returns: (transfer full): The new parameters set.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleRequestCommonParameters *
 purple_request_cpar_new(void);
 
@@ -238,7 +242,10 @@ purple_request_cpar_new(void);
  * Creates new parameters set initially bound with the #PurpleConnection.
  *
  * Returns: (transfer full): The new parameters set.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleRequestCommonParameters *
 purple_request_cpar_from_connection(PurpleConnection *gc);
 
@@ -249,7 +256,10 @@ purple_request_cpar_from_connection(Purp
  * Creates new parameters set initially bound with the #PurpleAccount.
  *
  * Returns: (transfer full): The new parameters set.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleRequestCommonParameters *
 purple_request_cpar_from_account(PurpleAccount *account);
 
@@ -260,7 +270,10 @@ purple_request_cpar_from_account(PurpleA
  * Creates new parameters set initially bound with the #PurpleConversation.
  *
  * Returns: (transfer full): The new parameters set.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleRequestCommonParameters *
 purple_request_cpar_from_conversation(PurpleConversation *conv);
 
@@ -269,7 +282,10 @@ purple_request_cpar_from_conversation(Pu
  * @cpar: The object to ref.
  *
  * Increases the reference count on the parameters set.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void
 purple_request_cpar_ref(PurpleRequestCommonParameters *cpar);
 
@@ -280,7 +296,10 @@ purple_request_cpar_ref(PurpleRequestCom
  * Decreases the reference count on the parameters set.
  *
  * The object will be destroyed when this reaches 0.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void
 purple_request_cpar_unref(PurpleRequestCommonParameters *cpar);
 
@@ -290,7 +309,10 @@ purple_request_cpar_unref(PurpleRequestC
  * @account: The #PurpleAccount to associate.
  *
  * Sets the #PurpleAccount associated with the request, or %NULL, if none is.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void
 purple_request_cpar_set_account(PurpleRequestCommonParameters *cpar,
 	PurpleAccount *account);
@@ -303,7 +325,10 @@ purple_request_cpar_set_account(PurpleRe
  *
  * Returns: (transfer none): The associated #PurpleAccount, or %NULL if none is
  *          set.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleAccount *
 purple_request_cpar_get_account(PurpleRequestCommonParameters *cpar);
 
@@ -314,7 +339,10 @@ purple_request_cpar_get_account(PurpleRe
  *
  * Sets the #PurpleConversation associated with the request, or %NULL, if
  * none is.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void
 purple_request_cpar_set_conversation(PurpleRequestCommonParameters *cpar,
 	PurpleConversation *conv);
@@ -327,7 +355,10 @@ purple_request_cpar_set_conversation(Pur
  *
  * Returns: (transfer none): The associated #PurpleConversation, or %NULL if
  *          none is set.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleConversation *
 purple_request_cpar_get_conversation(PurpleRequestCommonParameters *cpar);
 
@@ -337,7 +368,10 @@ purple_request_cpar_get_conversation(Pur
  * @icon_type: The icon type.
  *
  * Sets the icon associated with the request.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void
 purple_request_cpar_set_icon(PurpleRequestCommonParameters *cpar,
 	PurpleRequestIconType icon_type);
@@ -349,7 +383,10 @@ purple_request_cpar_set_icon(PurpleReque
  * Gets the icon associated with the request.
  *
  * Returns: icon_type The icon type.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleRequestIconType
 purple_request_cpar_get_icon(PurpleRequestCommonParameters *cpar);
 
@@ -360,7 +397,10 @@ purple_request_cpar_get_icon(PurpleReque
  * @icon_size: The icon image size.
  *
  * Sets the custom icon associated with the request.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void
 purple_request_cpar_set_custom_icon(PurpleRequestCommonParameters *cpar,
 	gconstpointer icon_data, gsize icon_size);
@@ -374,7 +414,10 @@ purple_request_cpar_set_custom_icon(Purp
  * Gets the custom icon associated with the request.
  *
  * Returns: The icon image contents.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gconstpointer
 purple_request_cpar_get_custom_icon(PurpleRequestCommonParameters *cpar,
 	gsize *icon_size);
@@ -387,7 +430,10 @@ purple_request_cpar_get_custom_icon(Purp
  *                redefined in the future.
  *
  * Switches the request text to be HTML or not.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void
 purple_request_cpar_set_html(PurpleRequestCommonParameters *cpar,
 	gboolean enabled);
@@ -399,7 +445,10 @@ purple_request_cpar_set_html(PurpleReque
  * Checks, if the text passed to the request is HTML.
  *
  * Returns: %TRUE, if the text is HTML, %FALSE otherwise.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean
 purple_request_cpar_is_html(PurpleRequestCommonParameters *cpar);
 
@@ -409,7 +458,10 @@ purple_request_cpar_is_html(PurpleReques
  * @compact: TRUE for compact, FALSE otherwise.
  *
  * Sets dialog display mode to compact or default.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void
 purple_request_cpar_set_compact(PurpleRequestCommonParameters *cpar,
 	gboolean compact);
@@ -421,7 +473,10 @@ purple_request_cpar_set_compact(PurpleRe
  * Gets dialog display mode.
  *
  * Returns: TRUE for compact, FALSE for default.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean
 purple_request_cpar_is_compact(PurpleRequestCommonParameters *cpar);
 
@@ -432,7 +487,10 @@ purple_request_cpar_is_compact(PurpleReq
  * @user_data: The data to be passed to the callback.
  *
  * Sets the callback for the Help button.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void
 purple_request_cpar_set_help_cb(PurpleRequestCommonParameters *cpar,
 	PurpleRequestHelpCb cb, gpointer user_data);
@@ -446,7 +504,10 @@ purple_request_cpar_set_help_cb(PurpleRe
  * Gets the callback for the Help button.
  *
  * Returns: (transfer none): The callback.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleRequestHelpCb
 purple_request_cpar_get_help_cb(PurpleRequestCommonParameters *cpar,
 	gpointer *user_data);
@@ -462,7 +523,10 @@ purple_request_cpar_get_help_cb(PurpleRe
  *        Should be terminated with the NULL label.
  *
  * Sets extra actions for the PurpleRequestPage dialog.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void
 purple_request_cpar_set_extra_actions(PurpleRequestCommonParameters *cpar, ...);
 
@@ -474,7 +538,10 @@ purple_request_cpar_set_extra_actions(Pu
  *
  * Returns: (element-type PurpleKeyValuePair) (transfer none): A list of actions (pairs of arguments, as in
  *          setter).
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GSList *
 purple_request_cpar_get_extra_actions(PurpleRequestCommonParameters *cpar);
 
@@ -485,7 +552,10 @@ purple_request_cpar_get_extra_actions(Pu
  *
  * Sets the same parent window for this dialog, as the parent of specified
  * Notify API or Request API dialog UI handle.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void
 purple_request_cpar_set_parent_from(PurpleRequestCommonParameters *cpar,
 	gpointer ui_handle);
@@ -497,7 +567,10 @@ purple_request_cpar_set_parent_from(Purp
  * Gets the parent "donor" for this dialog.
  *
  * Returns: The donors UI handle.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gpointer
 purple_request_cpar_get_parent_from(PurpleRequestCommonParameters *cpar);
 
@@ -725,7 +798,10 @@ purple_request_action_varg(void *handle,
  * Displays a "please wait" dialog.
  *
  * Returns: A UI-specific handle.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void *
 purple_request_wait(void *handle, const char *title, const char *primary,
 	const char *secondary, gboolean with_progress,
@@ -738,7 +814,10 @@ purple_request_wait(void *handle, const 
  *
  * Notifies the "please wait" dialog that some progress has been made, but you
  * don't know how much.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void
 purple_request_wait_pulse(void *ui_handle);
 
@@ -749,7 +828,10 @@ purple_request_wait_pulse(void *ui_handl
  *                  inclusive).
  *
  * Notifies the "please wait" dialog about progress has been made.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void
 purple_request_wait_progress(void *ui_handle, gfloat fraction);
 
@@ -798,7 +880,10 @@ purple_request_fields(void *handle, cons
  * Checks, if passed UI handle is valid.
  *
  * Returns: TRUE, if handle is valid, FALSE otherwise.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean
 purple_request_is_valid_ui_handle(void *ui_handle, PurpleRequestType *type);
 
@@ -809,7 +894,10 @@ purple_request_is_valid_ui_handle(void *
  * @notify_data: The data to be passed to the callback function.
  *
  * Adds a function called when notification dialog is closed.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void
 purple_request_add_close_notify(void *ui_handle, GDestroyNotify notify,
 	gpointer notify_data);
@@ -974,7 +1062,10 @@ purple_request_folder(void *handle, cons
  * The standard _get_type function for #PurpleRequestUiOps.
  *
  * Returns: The #GType for the #PurpleRequestUiOps boxed structure.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GType purple_request_ui_ops_get_type(void);
 
 /**
diff --git a/libpurple/request/purplerequestfield.h b/libpurple/request/purplerequestfield.h
--- a/libpurple/request/purplerequestfield.h
+++ b/libpurple/request/purplerequestfield.h
@@ -121,7 +121,10 @@ void purple_request_field_set_type_hint(
  *
  * This is optionally used by the UIs to provide a tooltip for
  * the field.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_request_field_set_tooltip(PurpleRequestField *field, const char *tooltip);
 
 /**
@@ -190,7 +193,10 @@ const char *purple_request_field_get_typ
  * Returns the field's tooltip.
  *
  * Returns: The field's tooltip.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const char *purple_request_field_get_tooltip(PurpleRequestField *field);
 
 /**
@@ -214,7 +220,10 @@ gboolean purple_request_field_is_require
  * notify on [property@RequestField:filled].
  *
  * Returns: TRUE if the field has value, or FALSE.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_request_field_is_filled(PurpleRequestField *field);
 
 /**
@@ -226,7 +235,10 @@ gboolean purple_request_field_is_filled(
  * @destroy_data: A cleanup function for @user_data.
  *
  * Set an additional validator for a field.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_request_field_set_validator(PurpleRequestField *field, PurpleRequestFieldValidator validator, gpointer user_data, GDestroyNotify destroy_data);
 
 /**
@@ -244,7 +256,10 @@ void purple_request_field_set_validator(
  * Note: Required, but unfilled, fields are invalid.
  *
  * Returns: TRUE, if the field is valid, FALSE otherwise.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_request_field_is_valid(PurpleRequestField *field, gchar **errmsg);
 
 /**
@@ -253,7 +268,10 @@ gboolean purple_request_field_is_valid(P
  * @sensitive: TRUE if the field should be sensitive for user input.
  *
  * Sets field editable.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_request_field_set_sensitive(PurpleRequestField *field, gboolean sensitive);
 
 /**
@@ -263,7 +281,10 @@ void purple_request_field_set_sensitive(
  * Checks, if field is editable.
  *
  * Returns: TRUE, if the field is sensitive for user input.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_request_field_is_sensitive(PurpleRequestField *field);
 
 G_END_DECLS
diff --git a/libpurple/request/purplerequestfieldchoice.h b/libpurple/request/purplerequestfieldchoice.h
--- a/libpurple/request/purplerequestfieldchoice.h
+++ b/libpurple/request/purplerequestfieldchoice.h
@@ -83,6 +83,7 @@ void purple_request_field_choice_add(Pur
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_request_field_choice_add_full(PurpleRequestFieldChoice *field, const char *label, gpointer data, GDestroyNotify destroy);
 
 /**
@@ -130,7 +131,10 @@ gpointer purple_request_field_choice_get
  * Returns a list of elements in a choice field.
  *
  * Returns: (element-type PurpleKeyValuePair) (transfer none): The list of pairs of {label, value}.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GList *purple_request_field_choice_get_elements(PurpleRequestFieldChoice *field);
 
 G_END_DECLS
diff --git a/libpurple/request/purplerequestfielddatasheet.h b/libpurple/request/purplerequestfielddatasheet.h
--- a/libpurple/request/purplerequestfielddatasheet.h
+++ b/libpurple/request/purplerequestfielddatasheet.h
@@ -58,7 +58,10 @@ G_DECLARE_FINAL_TYPE(PurpleRequestFieldD
  * Creates a datasheet item field.
  *
  * Returns: (transfer full): The new field.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleRequestField *purple_request_field_datasheet_new(const char *id, const gchar *text, PurpleRequestDatasheet *sheet);
 
 /**
@@ -68,7 +71,10 @@ PurpleRequestField *purple_request_field
  * Returns a datasheet for a field.
  *
  * Returns: (transfer none): The datasheet object.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleRequestDatasheet *purple_request_field_datasheet_get_sheet(PurpleRequestFieldDatasheet *field);
 
 G_END_DECLS
diff --git a/libpurple/request/purplerequestfieldint.h b/libpurple/request/purplerequestfieldint.h
--- a/libpurple/request/purplerequestfieldint.h
+++ b/libpurple/request/purplerequestfieldint.h
@@ -77,7 +77,10 @@ void purple_request_field_int_set_defaul
  * @lower_bound: The lower bound.
  *
  * Sets the lower bound in an integer field.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_request_field_int_set_lower_bound(PurpleRequestFieldInt *field, int lower_bound);
 
 /**
@@ -86,7 +89,10 @@ void purple_request_field_int_set_lower_
  * @upper_bound: The upper bound.
  *
  * Sets the upper bound in an integer field.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_request_field_int_set_upper_bound(PurpleRequestFieldInt *field, int upper_bound);
 
 /**
@@ -115,7 +121,10 @@ int purple_request_field_int_get_default
  * Returns the lower bound in an integer field.
  *
  * Returns: The lower bound.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 int purple_request_field_int_get_lower_bound(PurpleRequestFieldInt *field);
 
 /**
@@ -125,7 +134,10 @@ int purple_request_field_int_get_lower_b
  * Returns the upper bound in an integer field.
  *
  * Returns: The upper bound.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 int purple_request_field_int_get_upper_bound(PurpleRequestFieldInt *field);
 
 /**
diff --git a/libpurple/request/purplerequestfieldlist.h b/libpurple/request/purplerequestfieldlist.h
--- a/libpurple/request/purplerequestfieldlist.h
+++ b/libpurple/request/purplerequestfieldlist.h
@@ -171,6 +171,7 @@ GList *purple_request_field_list_get_ite
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_request_field_list_has_icons(PurpleRequestFieldList *field);
 
 G_END_DECLS
diff --git a/libpurple/request/purplerequestfieldstring.h b/libpurple/request/purplerequestfieldstring.h
--- a/libpurple/request/purplerequestfieldstring.h
+++ b/libpurple/request/purplerequestfieldstring.h
@@ -140,7 +140,10 @@ gboolean purple_request_field_string_is_
  * See [method@Purple.RequestField.set_validator].
  *
  * Returns: TRUE, if field contains valid email address.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_request_field_email_validator(PurpleRequestField *field, char **errmsg, gpointer user_data);
 
 /**
@@ -155,7 +158,10 @@ gboolean purple_request_field_email_vali
  * See [method@Purple.RequestField.set_validator].
  *
  * Returns: TRUE, if field contains only alphanumeric characters.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_request_field_alphanumeric_validator(PurpleRequestField *field, char **errmsg, gpointer allowed_characters);
 
 G_END_DECLS
diff --git a/libpurple/roomlist.h b/libpurple/roomlist.h
--- a/libpurple/roomlist.h
+++ b/libpurple/roomlist.h
@@ -107,7 +107,10 @@ G_BEGIN_DECLS
  * The standard _get_type function for #PurpleRoomlist.
  *
  * Returns: The #GType for the Room List object.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 G_DECLARE_FINAL_TYPE(PurpleRoomlist, purple_roomlist, PURPLE, ROOMLIST, GObject)
 
 /**
@@ -140,7 +143,10 @@ PurpleRoomlist *purple_roomlist_new(Purp
  * created.
  *
  * Returns: (transfer none): The PurpleAccount tied to this room list.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleAccount *purple_roomlist_get_account(PurpleRoomlist *list);
 
 /**
@@ -235,7 +241,10 @@ void purple_roomlist_join_room(PurpleRoo
  * The standard _get_type function for #PurpleRoomlistUiOps.
  *
  * Returns: The #GType for the #PurpleRoomlistUiOps boxed structure.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GType purple_roomlist_ui_ops_get_type(void);
 
 /**
diff --git a/libpurple/savedstatuses.h b/libpurple/savedstatuses.h
--- a/libpurple/savedstatuses.h
+++ b/libpurple/savedstatuses.h
@@ -62,6 +62,7 @@ typedef struct _PurpleSavedStatus     Pu
 typedef struct _PurpleSavedStatusSub  PurpleSavedStatusSub;
 
 #include "status.h"
+#include "purpleversion.h"
 
 G_BEGIN_DECLS
 
@@ -113,7 +114,10 @@ void purple_savedstatus_set_title(Purple
  * @type:    The type of saved status.
  *
  * Set the type for the given saved status.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_savedstatus_set_primitive_type(PurpleSavedStatus *status,
 							   PurpleStatusPrimitive type);
 
@@ -342,7 +346,10 @@ const char *purple_savedstatus_get_title
  * Return the type of a given saved status.
  *
  * Returns: The primitive type.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleStatusPrimitive purple_savedstatus_get_primitive_type(const PurpleSavedStatus *saved_status);
 
 /**
@@ -411,7 +418,10 @@ PurpleSavedStatusSub *purple_savedstatus
  * Get the status type of a given substatus.
  *
  * Returns: The status type.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const PurpleStatusType *purple_savedstatus_substatus_get_status_type(
 		const PurpleSavedStatusSub *substatus);
 
diff --git a/libpurple/server.h b/libpurple/server.h
--- a/libpurple/server.h
+++ b/libpurple/server.h
@@ -33,6 +33,7 @@
 #include "protocols.h"
 #include "purpleimconversation.h"
 #include "purplemessage.h"
+#include "purpleversion.h"
 
 G_BEGIN_DECLS
 
@@ -51,8 +52,11 @@ G_BEGIN_DECLS
  *         example, then Purple will wait five seconds, and if the Purple
  *         user is still typing then Purple will send another PURPLE_IM_TYPING
  *         message.
+ *
+ * Since: 3.0.0
  */
 /* TODO Could probably move this into the conversation API. */
+PURPLE_AVAILABLE_IN_3_0
 unsigned int purple_serv_send_typing(PurpleConnection *gc, const char *name, PurpleIMTypingState state);
 
 /**
@@ -62,7 +66,10 @@ unsigned int purple_serv_send_typing(Pur
  * @dest:   Destiny group.
  *
  * Move a buddy from one group to another on server.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_serv_move_buddy(PurpleBuddy *buddy, PurpleGroup *orig, PurpleGroup *dest);
 
 /**
@@ -73,7 +80,10 @@ void purple_serv_move_buddy(PurpleBuddy 
  * Sends the message to the user through the required protocol.
  *
  * Returns: The error value returned from the protocol interface function.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 int  purple_serv_send_im(PurpleConnection *gc, PurpleMessage *msg);
 
 /******************************************************************************
@@ -88,7 +98,10 @@ int  purple_serv_send_im(PurpleConnectio
  * @name:   The name of the remote user to send the invitation to.
  *
  * Invite a user to join a chat.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_serv_chat_invite(PurpleConnection *gc, int id, const char *message, const char *name);
 
 /**
@@ -97,7 +110,10 @@ void purple_serv_chat_invite(PurpleConne
  * @id:     The id of the chat to leave.
  *
  * Called when the user requests leaving a chat.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_serv_chat_leave(PurpleConnection *gc, int id);
 
 /**
@@ -118,7 +134,10 @@ void purple_serv_chat_leave(PurpleConnec
  *
  * Returns:  A positive number or 0 in case of success, a
  *           negative error number in case of failure.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 int  purple_serv_chat_send(PurpleConnection *gc, int id, PurpleMessage *msg);
 
 /******************************************************************************
@@ -130,7 +149,10 @@ int  purple_serv_chat_send(PurpleConnect
  * @buddy:  The Buddy.
  *
  * Save/store buddy's alias on server list/roster
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_serv_alias_buddy(PurpleBuddy *buddy);
 
 /**
@@ -141,7 +163,9 @@ void purple_serv_alias_buddy(PurpleBuddy
  *
  * Protocol should call this function when it retrieves an alias form the server.
  *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_serv_got_alias(PurpleConnection *gc, const char *who, const char *alias);
 
 /**
@@ -173,7 +197,10 @@ void purple_serv_got_private_alias(Purpl
  * purple_serv_got_typing_stopped instead.
  *
  * @todo Could probably move this into the conversation API.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_serv_got_typing(PurpleConnection *gc, const char *name, int timeout,
 					 PurpleIMTypingState state);
 
@@ -185,7 +212,10 @@ void purple_serv_got_typing(PurpleConnec
  * Called from a protocol when it has received a type stopped.
  *
  * @todo Could probably move this into the conversation API.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_serv_got_typing_stopped(PurpleConnection *gc, const char *name);
 
 /**
@@ -197,7 +227,10 @@ void purple_serv_got_typing_stopped(Purp
  * @mtime:  The timestamp of the message.
  *
  * This function is called by the protocol when it receives an IM message.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_serv_got_im(PurpleConnection *gc, const char *who, const char *msg,
 				 PurpleMessageFlags flags, time_t mtime);
 
@@ -206,7 +239,10 @@ void purple_serv_got_im(PurpleConnection
  * @gc:   The #PurpleConnection
  * @data: The hash function should be g_str_hash() and the equal
  *             function should be g_str_equal().
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_serv_join_chat(PurpleConnection *gc, GHashTable *data);
 
 /**
@@ -214,7 +250,10 @@ void purple_serv_join_chat(PurpleConnect
  * @gc: The #PurpleConnection 
  * @data: The hash function should be g_str_hash() and the equal
  *             function should be g_str_equal().
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_serv_reject_chat(PurpleConnection *gc, GHashTable *data);
 
 /**
@@ -228,7 +267,10 @@ void purple_serv_reject_chat(PurpleConne
  *                function should be g_str_equal().
  *
  * Called by a protocol when an account is invited into a chat.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_serv_got_chat_invite(PurpleConnection *gc, const char *name,
 						  const char *who, const char *message,
 						  GHashTable *data);
@@ -242,9 +284,13 @@ void purple_serv_got_chat_invite(PurpleC
  * Called by a protocol when an account has joined a chat.
  *
  * Returns: (transfer none): The resulting conversation.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleConversation *purple_serv_got_joined_chat(PurpleConnection *gc,
 									   int id, const char *name);
+
 /**
  * purple_serv_got_join_chat_failed:
  * @gc:      The connection on which chat joining failed
@@ -263,7 +309,10 @@ void purple_serv_got_join_chat_failed(Pu
  * @id: The id of the chat, as assigned by the protocol.
  *
  * Called by a protocol when an account has left a chat.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_serv_got_chat_left(PurpleConnection *g, int id);
 
 /**
@@ -276,7 +325,10 @@ void purple_serv_got_chat_left(PurpleCon
  * @mtime:   The time when the message was received.
  *
  * Called by a protocol when a message has been received in a chat.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_serv_got_chat_in(PurpleConnection *g, int id, const char *who,
 					  PurpleMessageFlags flags, const char *message, time_t mtime);
 
@@ -287,7 +339,10 @@ void purple_serv_got_chat_in(PurpleConne
  * @file:   The filename to send.
  *
  * Send a filename to a given contact.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_serv_send_file(PurpleConnection *gc, const char *who, const char *file);
 
 G_END_DECLS
diff --git a/libpurple/signals.h b/libpurple/signals.h
--- a/libpurple/signals.h
+++ b/libpurple/signals.h
@@ -30,6 +30,8 @@
 #include <glib.h>
 #include <glib-object.h>
 
+#include "purpleversion.h"
+
 /**
  * PurpleSignalMarshalFunc:
  * @cb: The #GCallback to call.
@@ -338,7 +340,10 @@ void purple_marshal_VOID__POINTER_POINTE
  *
  * A purple marshaller function for use with signals with a pointer and
  * two unsigned integer arguments.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_marshal_VOID__POINTER_UINT_UINT(
 		GCallback cb, va_list args, void *data, void **return_val);
 
diff --git a/libpurple/status.h b/libpurple/status.h
--- a/libpurple/status.h
+++ b/libpurple/status.h
@@ -167,7 +167,10 @@ PurpleStatusPrimitive purple_primitive_g
  * The standard _get_type function for #PurpleStatusType.
  *
  * Returns: The #GType for #PurpleStatusType.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GType purple_status_type_get_type(void);
 
 /**
@@ -417,7 +420,10 @@ const PurpleStatusType *purple_status_ty
  * The standard _get_type function for #PurpleStatusAttribute.
  *
  * Returns: The #GType for the #PurpleStatusAttribute boxed structure.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GType purple_status_attribute_get_type(void);
 
 /**
@@ -429,7 +435,10 @@ GType purple_status_attribute_get_type(v
  * Creates a new status attribute.
  *
  * Returns: A new status attribute.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleStatusAttribute *purple_status_attribute_new(const char *id, const char *name,
 									 GValue *value_type);
 
@@ -438,7 +447,10 @@ PurpleStatusAttribute *purple_status_att
  * @attr: The status attribute to destroy.
  *
  * Destroys a status attribute.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_status_attribute_destroy(PurpleStatusAttribute *attr);
 
 /**
@@ -448,7 +460,10 @@ void purple_status_attribute_destroy(Pur
  * Returns the ID of a status attribute.
  *
  * Returns: The status attribute's ID.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const char *purple_status_attribute_get_id(const PurpleStatusAttribute *attr);
 
 /**
@@ -458,7 +473,10 @@ const char *purple_status_attribute_get_
  * Returns the name of a status attribute.
  *
  * Returns: The status attribute's name.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const char *purple_status_attribute_get_name(const PurpleStatusAttribute *attr);
 
 /**
@@ -468,7 +486,10 @@ const char *purple_status_attribute_get_
  * Returns the value of a status attribute.
  *
  * Returns: The status attribute's value.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GValue *purple_status_attribute_get_value(const PurpleStatusAttribute *attr);
 
 /**************************************************************************/
@@ -532,7 +553,10 @@ void purple_status_set_active_with_attri
  * Returns the status's type.
  *
  * Returns: The status's type.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleStatusType *purple_status_get_status_type(PurpleStatus *status);
 
 /**
@@ -701,7 +725,10 @@ gint purple_status_compare(PurpleStatus 
  * Get the handle for the status subsystem.
  *
  * Returns: the handle to the status subsystem
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void *purple_statuses_get_handle(void);
 
 /**
diff --git a/libpurple/util.h b/libpurple/util.h
--- a/libpurple/util.h
+++ b/libpurple/util.h
@@ -74,7 +74,10 @@ void purple_util_uninit(void);
  *  See purple_util_write_data_to_file()
  *
  * Returns: TRUE if the file was written successfully.  FALSE otherwise.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean
 purple_util_write_data_to_cache_file(const char *filename, const char *data, gssize size);
 
@@ -91,7 +94,10 @@ purple_util_write_data_to_cache_file(con
  *  See purple_util_write_data_to_file()
  *
  * Returns: TRUE if the file was written successfully.  FALSE otherwise.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean
 purple_util_write_data_to_config_file(const char *filename, const char *data, gssize size);
 
@@ -108,7 +114,10 @@ purple_util_write_data_to_config_file(co
  *  See purple_util_write_data_to_file()
  *
  * Returns: TRUE if the file was written successfully.  FALSE otherwise.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean
 purple_util_write_data_to_data_file(const char *filename, const char *data, gssize size);
 
@@ -126,7 +135,10 @@ purple_util_write_data_to_data_file(cons
  *
  * Returns: An PurpleXmlNode tree of the contents of the given file.  Or NULL, if
  *         the file does not exist or there was an error reading the file.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleXmlNode *
 purple_util_read_xml_from_cache_file(const char *filename, const char *description);
 
@@ -144,7 +156,10 @@ purple_util_read_xml_from_cache_file(con
  *
  * Returns: An PurpleXmlNode tree of the contents of the given file.  Or NULL, if
  *         the file does not exist or there was an error reading the file.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleXmlNode *
 purple_util_read_xml_from_config_file(const char *filename, const char *description);
 
@@ -162,7 +177,10 @@ purple_util_read_xml_from_config_file(co
  *
  * Returns: An PurpleXmlNode tree of the contents of the given file.  Or NULL, if
  *         the file does not exist or there was an error reading the file.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleXmlNode *
 purple_util_read_xml_from_data_file(const char *filename, const char *description);
 
@@ -254,7 +272,10 @@ const char *purple_normalize(PurpleAccou
  * Checks, if a string is valid.
  *
  * Returns: TRUE, if string is valid, otherwise FALSE.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_validate(PurpleProtocol *protocol, const char *str);
 
 /**
@@ -330,7 +351,10 @@ char *purple_str_seconds_to_string(guint
  * Fills a NUL-terminated string with zeros and frees it.
  *
  * It should be used to free sensitive data, like passwords.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_str_wipe(gchar *str);
 
 /**
@@ -485,7 +509,10 @@ GValue *purple_value_dup(GValue *value);
  * @value:  The GValue to free.
  *
  * Frees a GValue.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_value_free(GValue *value);
 
 G_END_DECLS
